Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4502)
@@ -3189,18 +3864,19 @@
           flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
-          IF ( qr(k,j,i) <= eps_sb )  THEN
-             qr(k,j,i) = 0.0_wp
-             nr(k,j,i) = 0.0_wp
-          ELSE
-!
-!--          Adjust number of raindrops to avoid nonlinear effects in
-!--          sedimentation and evaporation of rain drops due to too small or
-!--          too big weights of rain drops (Stevens and Seifert, 2008).
-             IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
-                nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin * flag
-             ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
-                nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax * flag
-             ENDIF
-
+          IF ( .NOT.  microphysics_morrison_no_rain )  THEN
+             IF ( qr(k,j,i) <= eps_sb )  THEN
+                qr(k,j,i) = 0.0_wp
+                nr(k,j,i) = 0.0_wp
+             ELSE
+!
+!--             Adjust number of raindrops to avoid nonlinear effects in
+!--             sedimentation and evaporation of rain drops due to too small or
+!--             too big weights of rain drops (Stevens and Seifert, 2008).
+                IF ( nr(k,j,i) * xrmin > qr(k,j,i) * hyrho(k) )  THEN
+                   nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmin * flag
+                ELSEIF ( nr(k,j,i) * xrmax < qr(k,j,i) * hyrho(k) )  THEN
+                   nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax * flag
+                ENDIF
+             ENDIF
           ENDIF
 
@@ -3219,4 +3895,81 @@
 
     END SUBROUTINE adjust_cloud_ij
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Adjust number of ice crystal to avoid nonlinear effects in sedimentation and
+!> evaporation of ice crytals due to too small or too big weights
+!> of ice crytals (Stevens and Seifert, 2008).
+!------------------------------------------------------------------------------!
+    SUBROUTINE adjust_ice
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                 !<
+       INTEGER(iwp) ::  j                 !<
+       INTEGER(iwp) ::  k                 !<
+
+       REAL(wp) ::  flag                  !< flag to indicate first grid level above
+
+       CALL cpu_log( log_point_s(97), 'adjust_ice', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                IF ( qi(k,j,i) <= ximin )  THEN
+                   qi(k,j,i) = 0.0_wp
+                   ni(k,j,i) = 0.0_wp
+                ELSE
+                   IF ( ni(k,j,i) * ximin > qi(k,j,i) * hyrho(k) )  THEN
+                      ni(k,j,i) = qi(k,j,i) * hyrho(k) / ximin * flag
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(97), 'adjust_ice', 'stop' )
+
+    END SUBROUTINE adjust_ice
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Adjust number of of ice crystal to avoid nonlinear effects in
+!> sedimentation and evaporation of ice crystals due to too small or
+!> too big weights of ice crytals (Stevens and Seifert, 2008).
+!> The same procedure is applied to cloud droplets if they are determined
+!> prognostically. Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE adjust_ice_ij( i, j )
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i                 !<
+       INTEGER(iwp) ::  j                 !<
+       INTEGER(iwp) ::  k                 !<
+
+       REAL(wp) ::  flag                  !< flag to indicate first grid level above surface
+
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+          IF ( qi(k,j,i) <= ximin )  THEN
+             qi(k,j,i) = 0.0_wp
+             ni(k,j,i) = 0.0_wp
+          ELSE
+             IF ( ni(k,j,i) * ximin > qi(k,j,i) * hyrho(k) )  THEN
+                ni(k,j,i) = qi(k,j,i) * hyrho(k) / ximin * flag
+             ENDIF
+          ENDIF
+       ENDDO
+
+    END SUBROUTINE adjust_ice_ij
+
 
 !------------------------------------------------------------------------------!
@@ -3423,4 +4176,136 @@
     END SUBROUTINE activation_ij
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate ice nucleation by applying the deposition-condensation formula as
+!> given by Meyers et al 1992 and as described in Seifert and Beheng 2006
+!------------------------------------------------------------------------------!
+    SUBROUTINE ice_nucleation
+
+       INTEGER(iwp) ::  i             !< loop index
+       INTEGER(iwp) ::  j             !< loop index
+       INTEGER(iwp) ::  k             !< loop index
+
+       LOGICAL :: isdac = .TRUE.
+
+       REAL(wp) ::  a_m92 = -0.639_wp !< parameter for nucleation
+       REAL(wp) ::  b_m92 = 12.96_wp  !< parameter for nucleation
+       REAL(wp) ::  flag              !< flag to indicate first grid level
+       REAL(wp) ::  n_in              !< number of ice nucleii
+       REAL(wp) ::  nucle = 0.0_wp    !< nucleation rate
+
+       CALL cpu_log( log_point_s(93), 'ice_nucleation', 'start' )
+
+       IF  ( isdac )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+!
+!--                Predetermine flag to mask topography
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--                Call calculation of supersaturation located in subroutine
+                   CALL supersaturation_ice ( i, j, k )
+                   nucle = 0.0_wp
+                   !IF ( zu(k) >= 1500.0_wp ) CYCLE
+                   IF ( sat_ice >= 0.05_wp  .OR.  ql(k,j,i) >= 0.001E-3_wp  ) THEN
+!
+!--                   Calculate ice nucleation
+                      nucle = MAX( ( in_init - ni(k,j,i) ) / dt_micro, 0.0_wp )
+                      !qi(k,j,i) = qi(k,j,i) + nucle * dt_micro * ximin
+                      ni(k,j,i) = MIN( (ni(k,j,i) + nucle * dt_micro * flag), in_init)
+                   ENDIF
+
+                ENDDO
+             ENDDO
+          ENDDO
+       ELSE
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+!
+!--                Predetermine flag to mask topography
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--                Call calculation of supersaturation located in subroutine
+                   CALL supersaturation_ice ( i, j, k )
+                   nucle = 0.0_wp
+                   IF ( sat_ice > 0.0 ) THEN
+!
+!--                   Calculate ice nucleation
+                      n_in = in_init * EXP( a_m92 + b_m92 * sat_ice )
+                      nucle = MAX( ( n_in - ni(k,j,i) ) / dt_micro, 0.0_wp )
+                   ENDIF
+                   ni(k,j,i) = MIN( (ni(k,j,i) + nucle * dt_micro * flag), 1.0E10_wp )
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+
+       CALL cpu_log( log_point_s(93), 'ice_nucleation', 'stop' )
+
+    END SUBROUTINE ice_nucleation
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate ice nucleation by applying the deposition-condensation formula as
+!> given by Meyers et al 1992 and as described in Seifert and Beheng 2006
+!------------------------------------------------------------------------------!
+    SUBROUTINE ice_nucleation_ij( i, j )
+
+       INTEGER(iwp) ::  i             !< loop index
+       INTEGER(iwp) ::  j             !< loop index
+       INTEGER(iwp) ::  k             !< loop index
+
+       LOGICAL :: isdac = .TRUE.
+
+       REAL(wp) ::  a_m92 = -0.639_wp !< parameter for nucleation
+       REAL(wp) ::  b_m92 = 12.96_wp  !< parameter for nucleation
+       REAL(wp) ::  flag              !< flag to indicate first grid level
+       REAL(wp) ::  n_in              !< number of ice nucleii
+       REAL(wp) ::  nucle = 0.0_wp    !< nucleation rate
+
+       IF ( isdac )  THEN
+          DO  k = nzb+1, nzt
+!
+!--          Predetermine flag to mask topography
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--          Call calculation of supersaturation located in subroutine
+             CALL supersaturation_ice ( i, j, k )
+             nucle = 0.0_wp
+             !IF ( zu(k) >= 1500.0_wp ) CYCLE
+             IF ( sat_ice >= 0.05_wp  .OR.  ql(k,j,i) >= 0.001E-3_wp ) THEN
+!
+!--             Calculate ice nucleation
+                nucle = MAX( ( in_init - ni(k,j,i) ) / dt_micro, 0.0_wp )
+                !qi(k,j,i) = qi(k,j,i) + nucle * dt_micro * ximin
+                ni(k,j,i) = MIN( (ni(k,j,i) + nucle * dt_micro * flag), in_init)
+             ENDIF
+          ENDDO
+       ELSE
+          DO  k = nzb+1, nzt
+!
+!--          Predetermine flag to mask topography
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--          Call calculation of supersaturation located in subroutine
+             CALL supersaturation_ice ( i, j, k )
+             nucle = 0.0_wp
+             IF ( sat_ice > 0.0 ) THEN
+!
+!--             Calculate ice nucleation
+                n_in = in_init * EXP( a_m92 + b_m92 * sat_ice )
+                nucle = MAX( ( n_in - ni(k,j,i) ) / dt_micro, 0.0_wp )
+             ENDIF
+             ni(k,j,i) = MIN( (ni(k,j,i) + nucle * dt_micro * flag), 1.0E10_wp )
+          ENDDO
+       ENDIF
+
+
+    END SUBROUTINE ice_nucleation_ij
 
 !------------------------------------------------------------------------------!
@@ -3434,18 +4319,17 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                 !<
-       INTEGER(iwp) ::  j                 !<
-       INTEGER(iwp) ::  k                 !<
-
-       REAL(wp)     ::  cond              !<
-       REAL(wp)     ::  cond_max          !<
-       REAL(wp)     ::  dc                !<
-       REAL(wp)     ::  evap              !<
-       REAL(wp)     ::  g_fac             !<
-       REAL(wp)     ::  nc_0              !<
-       REAL(wp)     ::  temp              !<
-       REAL(wp)     ::  xc                !<
-
-       REAL(wp) ::  flag                  !< flag to indicate first grid level above
+       INTEGER(iwp) ::  i                 !< loop index
+       INTEGER(iwp) ::  j                 !< loop index
+       INTEGER(iwp) ::  k                 !< loop index
+
+       REAL(wp)     ::  cond              !< condensation rate
+       REAL(wp)     ::  cond_max          !< maximum condensation rate
+       REAL(wp)     ::  dc                !< weight avageraed diameter
+       REAL(wp)     ::  evap              !< evaporation rate
+       REAL(wp)     ::  flag              !< flag to indicate first grid level above surface
+       REAL(wp)     ::  g_fac             !< factor 1 / Fk + Fd
+       REAL(wp)     ::  nc_0              !< integral diameter
+       REAL(wp)     ::  temp              !< actual temperature
+       REAL(wp)     ::  xc                !< mean mass droplets
 
        CALL cpu_log( log_point_s(66), 'condensation', 'start' )
@@ -3461,10 +4345,11 @@
                 CALL supersaturation ( i, j, k )
 !
-!--             Actual temperature:
-                IF ( microphysics_seifert ) THEN
-                   temp = t_l + lv_d_cp * ( qc(k,j,i) + qr(k,j,i) )
-                ELSEIF ( microphysics_morrison_no_rain ) THEN
-                   temp = t_l + lv_d_cp * qc(k,j,i) 
-                ENDIF  
+!--             Actual temperature, t_l is calculated directly before
+!--             in supersaturation
+                IF ( microphysics_ice_extension ) THEN
+                   temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
+                ELSE
+                   temp = t_l + lv_d_cp * ql(k,j,i)
+                ENDIF
 
                 g_fac  = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) *        &
@@ -3525,18 +4410,17 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                 !<
-       INTEGER(iwp) ::  j                 !<
-       INTEGER(iwp) ::  k                 !<
-
-       REAL(wp)     ::  cond              !<
-       REAL(wp)     ::  cond_max          !<
-       REAL(wp)     ::  dc                !<
-       REAL(wp)     ::  evap              !<
+       INTEGER(iwp) ::  i                 !< loop index
+       INTEGER(iwp) ::  j                 !< loop index
+       INTEGER(iwp) ::  k                 !< loop index
+
+       REAL(wp)     ::  cond              !< condensation rate
+       REAL(wp)     ::  cond_max          !< maximum condensation rate
+       REAL(wp)     ::  dc                !< weight avageraed diameter
+       REAL(wp)     ::  evap              !< evaporation rate
        REAL(wp)     ::  flag              !< flag to indicate first grid level above surface
-       REAL(wp)     ::  g_fac             !<
-       REAL(wp)     ::  nc_0              !<
-       REAL(wp)     ::  temp              !<
-       REAL(wp)     ::  xc                !<
-
+       REAL(wp)     ::  g_fac             !< factor 1 / Fk + Fd
+       REAL(wp)     ::  nc_0              !< integral diameter
+       REAL(wp)     ::  temp              !< actual temperature
+       REAL(wp)     ::  xc                !< mean mass droplets
 
        DO  k = nzb+1, nzt
@@ -3548,14 +4432,15 @@
           CALL supersaturation ( i, j, k )
 !
-!--       Actual temperature:
-          IF ( microphysics_seifert ) THEN
-             temp = t_l + lv_d_cp * ( qc(k,j,i) + qr(k,j,i) )
-          ELSEIF ( microphysics_morrison_no_rain ) THEN
-             temp = t_l + lv_d_cp * qc(k,j,i) 
-          ENDIF  
-
-          g_fac  = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) *        &
-                              l_v / ( thermal_conductivity_l * temp )    &
-                              + r_v * temp / ( diff_coeff_l * e_s )      &
+!--       Actual temperature, t_l is calculated directly before
+!--       in supersaturation
+          IF ( microphysics_ice_extension ) THEN
+             temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
+          ELSE
+             temp = t_l + lv_d_cp * ql(k,j,i)
+          ENDIF
+
+          g_fac  = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) *              &
+                              l_v / ( thermal_conductivity_l * temp )          &
+                              + r_v * temp / ( diff_coeff_l * e_s )            &
                             )
 !
@@ -3594,4 +4479,182 @@
 
     END SUBROUTINE condensation_ij
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate the growth of ice particles by water vapor deposition (after
+!> Seifert and Beheng, 2006).
+!------------------------------------------------------------------------------!
+    SUBROUTINE ice_deposition
+
+       INTEGER(iwp) ::  i                 !< loop index
+       INTEGER(iwp) ::  j                 !< loop index
+       INTEGER(iwp) ::  k                 !< loop index
+
+       REAL(wp) ::  ac = 0.09_wp        !< parameter for ice capacitance
+       REAL(wp) ::  bc = 0.33_wp        !< parameter for ice capacitance
+       REAL(wp) ::  fac_gamma = 0.76_wp !< parameter to describe spectral
+                                        !< distribution, here following gamma
+                                        !< size distribution with Âµ =1/3 and nu=0
+       REAL(wp) ::  deposition_rate     !< depositions rate
+       REAL(wp) ::  deposition_rate_max !< maximum deposition rate
+       REAL(wp) ::  sublimation_rate    !< sublimations rate
+       REAL(wp) ::  gfac_dep            !< factor
+       REAL(wp) ::  temp                !< actual temperature
+       REAL(wp) ::  xi                  !< mean mass of ice crystal
+       REAL(wp) ::  flag                !< flag to indicate first grid level above
+
+       CALL cpu_log( log_point_s(95), 'ice deposition', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--             Call calculation of supersaturation over a plane ice surface
+                CALL supersaturation_ice ( i, j, k )
+!
+!--             Actual temperature:
+                temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
+
+                IF ( temp >= 273.15_wp ) CYCLE
+!
+!--             calculating gfac_dep ( 1/ (Fk + Fd) ) see e.g.
+!--             Rogers and Yau, 1989
+                gfac_dep  = 1.0_wp / ( ( l_s / ( r_v * temp ) - 1.0_wp ) *     &
+                                    l_s / ( thermal_conductivity_l * temp )    &
+                                    + r_v * temp / ( diff_coeff_l * e_si )     &
+                                    )
+!
+!--             If there is nothing nucleated, than there is also no
+!--             deposition (above -38Â°C)
+                IF ( ni(k,j,i) <= 0.0_wp ) CYCLE
+!
+!--             calculate mean mass of ice crystal
+                xi = 0.0_wp
+                xi = MAX( ( qi(k,j,i) * hyrho(k) / ni(k,j,i)), ximin )
+!
+!--             Condensation needs only to be calculated in supersaturated
+!--             regions (regarding ice)
+                IF ( sat_ice > 0.0_wp )  THEN
+!
+!--                Calculate deposition rate assuming ice crystal shape as
+!--                prescribed in Ovchinnikov et al., 2014 and a gamma size
+!--                distribution according to Seifert and Beheng with to
+!--                Âµ =1/3 and nu=0
+                   deposition_rate  = 4.0_wp * pi * sat_ice * gfac_dep *       &
+                                      fac_gamma * ac * xi**bc * ni(k,j,i)
+                   IF ( microphysics_seifert ) THEN
+                      deposition_rate_max  = q(k,j,i) -                        &
+                                             q_si - qr(k,j,i) - qi(k,j,i)
+                   ELSEIF ( microphysics_morrison_no_rain ) THEN
+                      deposition_rate_max  = q(k,j,i) -                        &
+                                             q_si - qc(k,j,i) - qi(k,j,i)
+                   ENDIF
+                   deposition_rate = MIN( deposition_rate,                     &
+                                          deposition_rate_max / dt_micro )
+
+                   qi(k,j,i) = qi(k,j,i) + deposition_rate * dt_micro * flag
+                ELSEIF ( sat_ice < 0.0_wp ) THEN
+                   sublimation_rate = 4.0_wp * pi * sat_ice * gfac_dep *       &
+                                      fac_gamma * ac * xi**bc * ni(k,j,i)
+                   sublimation_rate = MAX( sublimation_rate,                   &
+                                           -qi(k,j,i) / dt_micro )
+                   qi(k,j,i) = qi(k,j,i) + sublimation_rate * dt_micro * flag
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(95), 'ice deposition', 'stop' )
+
+    END SUBROUTINE ice_deposition
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate condensation rate for cloud water content (after Khairoutdinov and
+!> Kogan, 2000).
+!------------------------------------------------------------------------------!
+    SUBROUTINE ice_deposition_ij( i, j )
+
+       INTEGER(iwp) ::  i                 !< loop index
+       INTEGER(iwp) ::  j                 !< loop index
+       INTEGER(iwp) ::  k                 !< loop index
+
+       REAL(wp) ::  ac = 0.09_wp        !< parameter for ice capacitance
+       REAL(wp) ::  bc = 0.33_wp        !< parameter for ice capacitance
+       REAL(wp) ::  fac_gamma = 0.76_wp !< parameter to describe spectral
+                                        !< distribution, here following gamma
+                                        !< size distribution with nu=1, v=0
+       REAL(wp) ::  deposition_rate     !< depositions rate
+       REAL(wp) ::  deposition_rate_max !< maximum deposition rate
+       REAL(wp) ::  sublimation_rate    !< sublimations rate
+       REAL(wp) ::  gfac_dep            !< factor
+       REAL(wp) ::  temp                !< actual temperature
+       REAL(wp) ::  xi                  !< mean mass of ice crystal
+       REAL(wp) ::  flag                !< flag to indicate first grid level above
+
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--       Call calculation of supersaturation over a plane ice surface
+          CALL supersaturation_ice ( i, j, k )
+!
+!--       Actual temperature:
+          temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
+
+          IF ( temp >= 273.15_wp ) CYCLE
+!
+!--       calculating gfac_dep ( 1/ (Fk + Fd) ) see e.g.
+!--       Rogers and Yau, 1989
+          gfac_dep  = 1.0_wp / ( ( l_s / ( r_v * temp ) - 1.0_wp ) *           &
+                              l_s / ( thermal_conductivity_l * temp )          &
+                              + r_v * temp / ( diff_coeff_l * e_si )           &
+                              )
+!
+!--       If there is nothing nucleated, than there is also no
+!--       deposition (above -38Â°C)
+          IF ( ni(k,j,i) <= 0.0_wp ) CYCLE
+!
+!--       calculate mean mass of ice crystal
+          xi = 0.0_wp
+          xi = MAX( ( qi(k,j,i) * hyrho(k) / ni(k,j,i)), ximin )
+!
+!--       Condensation needs only to be calculated in supersaturated
+!--       regions (regarding ice)
+          IF ( sat_ice > 0.0_wp )  THEN
+!
+!--          Calculate deposition rate assuming ice crystal shape as
+!--          prescribed in Ovchinnikov et al., 2014 and a gamma size
+!--          distribution according to Seifert and Beheng with to
+!--          Âµ =1/3 and nu=0
+             deposition_rate  = 4.0_wp * pi * sat_ice * gfac_dep *             &
+                                fac_gamma * ac * xi**bc * ni(k,j,i)
+             IF ( microphysics_seifert ) THEN
+                deposition_rate_max  = q(k,j,i) -                              &
+                                       q_si - qr(k,j,i) - qi(k,j,i)
+             ELSEIF ( microphysics_morrison_no_rain ) THEN
+                deposition_rate_max  = q(k,j,i) -                              &
+                                       q_si - qc(k,j,i) - qi(k,j,i)
+             ENDIF
+             deposition_rate = MIN( deposition_rate,                           &
+                                    deposition_rate_max / dt_micro )
+
+             qi(k,j,i) = qi(k,j,i) + deposition_rate * dt_micro * flag
+          ELSEIF ( sat_ice < 0.0_wp ) THEN
+             sublimation_rate = 4.0_wp * pi * sat_ice * gfac_dep *             &
+                                fac_gamma * ac * xi**bc * ni(k,j,i)
+             sublimation_rate = MAX( sublimation_rate,                         &
+                                     -qi(k,j,i) / dt_micro )
+             qi(k,j,i) = qi(k,j,i) + sublimation_rate * dt_micro * flag
+          ENDIF
+       ENDDO
+
+    END SUBROUTINE ice_deposition_ij
 
 
@@ -3823,5 +4886,5 @@
 !--          Autoconversion rate (Seifert and Beheng, 2006):
              autocon = k_au * ( nu_c + 2.0_wp ) * ( nu_c + 4.0_wp ) /          &
-                       ( nu_c + 1.0_wp )**2 * qc(k,j,i)**2 * xc**2 *            &
+                       ( nu_c + 1.0_wp )**2 * qc(k,j,i)**2 * xc**2 *           &
                        ( 1.0_wp + phi_au / ( 1.0_wp - tau_cloud )**2 ) *       &
                        rho_surface
@@ -4055,5 +5118,5 @@
           ENDIF
 
-          IF ( ( qc(k,j,i) > eps_sb )  .AND.  ( qr(k,j,i) > eps_sb )  .AND.  &
+          IF ( ( qc(k,j,i) > eps_sb )  .AND.  ( qr(k,j,i) > eps_sb )  .AND.    &
                ( nc_accr > eps_mr ) )  THEN
 !
@@ -4082,5 +5145,5 @@
 !
 !--          Accretion rate (Seifert and Beheng, 2006):
-             accr = k_cr * qc(k,j,i) * qr(k,j,i) * phi_ac *                      &
+             accr = k_cr * qc(k,j,i) * qr(k,j,i) * phi_ac *                    &
                     SQRT( rho_surface * hyrho(k) )
              accr = MIN( accr, qc(k,j,i) / dt_micro )
@@ -4089,5 +5152,5 @@
              qc(k,j,i) = qc(k,j,i) - accr * dt_micro * flag
              IF ( microphysics_morrison )  THEN
-                nc(k,j,i) = nc(k,j,i) - MIN( nc(k,j,i), accr / xc *               &
+                nc(k,j,i) = nc(k,j,i) - MIN( nc(k,j,i), accr / xc *            &
                                              hyrho(k) * dt_micro * flag        &
                                          )
@@ -4587,5 +5650,5 @@
              IF ( qc(k,j,i) > eps_sb  .AND.  nc(k,j,i) > eps_mr )  THEN
                 sed_nc(k) = sed_qc_const *                                     &
-                            ( qc(k,j,i) * hyrho(k) )**( 2.0_wp / 3.0_wp ) *     &
+                            ( qc(k,j,i) * hyrho(k) )**( 2.0_wp / 3.0_wp ) *    &
                             ( nc(k,j,i) )**( 1.0_wp / 3.0_wp )
              ELSE
@@ -4594,8 +5657,8 @@
 
              sed_nc(k) = MIN( sed_nc(k), hyrho(k) * dzu(k+1) *                 &
-                              nc(k,j,i) / dt_micro + sed_nc(k+1)                &
+                              nc(k,j,i) / dt_micro + sed_nc(k+1)               &
                             ) * flag
 
-             nc(k,j,i) = nc(k,j,i) + ( sed_nc(k+1) - sed_nc(k) ) *               &
+             nc(k,j,i) = nc(k,j,i) + ( sed_nc(k+1) - sed_nc(k) ) *             &
                                          ddzu(k+1) / hyrho(k) * dt_micro * flag
           ENDIF
@@ -4608,13 +5671,13 @@
           ENDIF
 
-          sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q(k,j,i) /          &
+          sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q(k,j,i) /         &
                                       dt_micro + sed_qc(k+1)                   &
                          ) * flag
 
-          q(k,j,i)  = q(k,j,i)  + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
+          q(k,j,i)  = q(k,j,i)  + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * dt_micro * flag
-          qc(k,j,i) = qc(k,j,i) + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
+          qc(k,j,i) = qc(k,j,i) + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * dt_micro * flag
-          pt(k,j,i) = pt(k,j,i) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
+          pt(k,j,i) = pt(k,j,i) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * lv_d_cp * d_exner(k) * dt_micro     &
                                                                 * flag
